##############  No Trains
nhv = '--- New Hope Valley Railway ---'
from sys import argv    #used to get file name
import os
from time import *
import time
import threading
from datetime import datetime
bootlog = 1
notrains = False




###
### version no_trains3  adds launch time to bootlog
### version no_trains4 made it full screen There is not exit mode
###                            use ctrl-c on boot up to stop
### version no_trains5  full screen and no cursor
### version no_trains6 added the next ride day
### version no_trains6-1 fixes the next ride day
###   from for x in range(10,49) to for x in range 5 to len(index))
### version 7 adds number of trains and OAL
### version 7-1 fixes 1 train
### version 7-5-1 adds a space in displayb  after sdate with OAL in
### version 7-5-4 Changes Trains to Trian if snot =1.
###                 Moves next trains display toleft edge
### version 8 adds days_out and make_date functions
### Version 8-1 corrected the math error. Added 1 to the timedelta
### Version 8-2 corrected error in date for lines displayc and displayd.
###     passed sdate[] variable through make_date() to make consistant date string
### Version 8-3  Centered date 240-5.4*len(Top_date)  5.4 is a guess!!
### Version 8-4 Deletes a space in displayd to match displayc
### Version 8-5  Corrects days out. Detects : when next day is 1
### Version 8-6 shifted text changed displayc to display2 displayd to display1
#                added next 4 ride days.
### Version 8-7  Made 3 displays for each of the 4 lines to align columns
### Version 8-7-1  Add the days_out to AOL ride days
### Version 9-1  Fixed end of year problem
### Version 9-1-1  Change the time varible to timea so that time.sleep() works
### Version 9-1-2  Changed   ds = days_out[7:10] to ds = days_out[7:11]
###                 For days_out > 99
### Version 9-1-3 Change offc from 340 to 330 and timee from (35,55) to (35,60)
### Version 9-1-4 deleted change in 9-1-2 after the system crashed in jan 2024
### Version 9-5 Added the variable m to magnify the images for large screens
###  m=1 for 3.5 inch display
### The l versions have the m = 2 for large screens 

#m= argv[1]  ## for large screens
### Version 9-5-1 added argv[1] to change magnification
###        with try and execpt  to make magnification 1 if no data is added
###        ie no_trainsx.py instead of no_trainsx.py 2


ver ='no_trains9-5-1  DO>99'

script = argv   # This is the file name

try:  # Sets m = 1 if no data is available to pass 
    m=int(argv[1]) # Magnification of the images
except:
    m=1

print ('Version: '+ver)

def convert24(timea):
    colon = (time.find(':'))
    
    if colon <2:
        timea = '0'+timea
    meridian = timea[-2:]        # "AM" or "PM"
    
    if meridian =='AM' and timea[0:2] !='12':
        return timea[0:5]+':00'
    elif timea[0:2] =='12':
        return timea[0:5] + ':00'
    
    elif meridian =='PM':
        print (str((int(timea[0:2])+12))+timea[2:5])
        return str((int(timea[0:2])+12))+timea[2:5]+':00'

#######################################################    
#######################################################  
def convert_to_min(strx):   # hh:mm:ss to seconds
    sec = 3600*int(strx[0:2]) + 60*int(strx[3:5]) + int(strx[7:9])
    
    return int(sec/60)


def hms(n):
    
    time_format = time.strftime("%H:%M", time.gmtime(n))
    return time_format
    #print("Time in preferred format :-",time_format)


def conv_min(minutes):   # Converts minutes to HH:MM
    hm =  '{:02d}:{:02d}'.format(*divmod(minutes, 60))
    return '{:02d}:{:02d}'.format(*divmod(minutes, 60))


def make_date(a): #enter date output mm/dd/yyyy
    b=a
    if a[1]=='/':
        a='0'+a
    if a[4] =='/':
        a=a[0:3] + '0'+a[3]
    else:
        a=a[0:3] +a[3:5] 
    a = a+'/20'+ b[-2:]
    return a

def days_out(a):
    mo=int(a[0:2])
    da = int(a[3:5])
    ye = int(a[6:10])
    date1 = datetime.now()
    date2 = datetime(day = da,month =mo, year =ye)
    timedelta = date2 - date1
    comma = str(timedelta).find(',')
    days_out='In ' +str(timedelta)[0:comma]+' on '
    days_out = '     In ' +str(timedelta)[0:comma]
    #### we nedd to add 1 to days_out()
    kk1=days_out[0:8]
    ds = days_out[7:10]  # was 7:10 but now it displasy days out >99
    ##  changed days_out[7:11] back to [7:10] system crashed in jan 2024!!
    ddd =int(ds) +1

    days_out =kk1+str(ddd) +' days'   
    time.sleep(2)
        

    if str(timedelta)[2:3] == ':':  # detects zero days ie tomorrow
        days_out = '  TOMORROW'
    return days_out


#### days_out2() was added for the end of the year problem
def days_out2(a):  #Used for finding no trains. a is a string in mm-dd-yyyy Use
    mo=int(a[0:2])
    da = int(a[3:5])
    ye = int(a[6:10])
    date1 = datetime.now()
    date2 = datetime(day = da,month =mo, year =ye)
    timedelta = date2 - date1
    comma = str(timedelta).find(',')
    days_out='In ' +str(timedelta)[0:comma]+' on '
    days_out = '     In ' +str(timedelta)[0:comma]
    #### we nedd to add 1 to days_out()
    kk1=days_out[0:8]
    ds = days_out[7:10]
    ddd =int(ds) +1

    return ddd



    
#######################################################   
#######################################################

######  Section 3

#### For countdown, load_schedule
#####  load_schedule4.py
from datetime import datetime
import csv

index = []
sdate =[]
sdow = []
snot = []
strain1 =[]
strain2 = []
strain3 = []
strain4 = []
strain5 = []
stheme =[]

i=0
todayy = datetime.now()

########################  IMPORT the schedule.csv file
f = open('schedule.csv') 
csvf = csv.reader(f)
for row in csvf:
    index.append(row[0])
    sdate.append(row[1])
    sdow.append(row[2])
    snot.append(row[3])
    strain1.append(row[4])
    strain2.append(row[5])
    strain3.append(row[6])
    strain4.append(row[7])
    strain5.append(row[8])
    stheme.append(row[11])
print ('Today is :',datetime.now())


###This section test for end of year problem 12/23/23 

aaa = sdate[len(index)-1] ## The last ride day of year. Don't know why -1 is needed
print('aaa is :',aaa)
print (days_out2(aaa))
       
if days_out2(aaa) <0:
    print ('There are no more trains this year')
    notrains =True


    

#print (notrains)




##### find the next ride date
if notrains == False:       
    for x in range(5,len(index)):
        print (x)
        
        print(sdate[x])
        print('datetime.now() is:  ')
        print     (datetime.now())
        print ('sdate[x[ is: ' ,datetime.strptime(sdate[x],'%m/%d/%Y'))
        if datetime.strptime(sdate[x],'%m/%d/%Y')  > datetime.now():
            #Today's train or trains have already run
            nexttrain = x  ##this is the next operating day
            break

           
           
    print ('This is the end')
    print ('The next schedlued train is on ', sdate[nexttrain])
    time.sleep(1)


############# Section 4  Change the strainx times with datetime    


#current date
now = datetime.now() # current date and time
#print (now)
#print('>>>>>>>>>>>>>')

Top_date= now.strftime("%A, %B %d, %Y")
#print (Top_date)


syear = now.strftime("%Y")
#print("syear:", syear)

smonth = now.strftime("%m")
#print ('smonth ', smonth)

if smonth[0:1] =='0':
    smonth=smonth[-1]
    #print ('smonth ',smonth)
    

sday = now.strftime("%d")
#print("sday:", sday)

if sday[0:1] =='0':
    sday = sday[-1]
    #print ('sday ',sday)

timea = now.strftime("%I:%M %p")
#print ('time ',time)

todayy= smonth+'/'+sday+'/'+syear

############## Section 5  Search for the schedule for today

#####cza######## Change string to seconds from midnight




#########################################    

#####################################          


#print ('PPPPPPPPPPddPPP')


 ###########################################################




############################################################
#Define Colours
WHITE = (255,255,255)
BLUE = (0,0,255)
BLACK = (0,0,0)
GRAY = (128, 128, 128)
MAROON = (128, 0, 0)
NAVYBLUE = (0, 0, 128)
OLIVE = (128, 128, 0)
PURPLE = (128, 0, 128)
TEAL = (0,128,128)
PINK = (226,132,164)
MUTEDBLUE = (155,182,203)
PLUM = (221,160,221)
############################################################



########################################


import pygame
pygame.init()

screen = pygame.display.set_mode((0,800))  # Sets the screen size
screen.fill((0,0,0))  #Fills the bbackgroud with black


pygame.display.set_caption(str(script)+' '+ ver)  # Title of window
ball = pygame.image.load('nhvrr350.jpg').convert()

new_size = (m*350,m*40)
ball =pygame.transform.scale(ball,new_size)




#ball = pygame.image.load('/home/pi/speedometer/nhvrr350.jpg').convert()
# The next line clears the speed before it is updated
#clr_speed = pygame.image.load('/home/pi/speedometer/clrscreen.jpg').convert()
clr_speed = pygame.image.load('clrscreen.jpg').convert()
pygame.display.set_mode((m*480,m*320),0,32) ## sets full screen

##DISPLAYSURF = pygame.display.set_mode((m*480, m*320), pygame.FULLSCREEN)

pygame.mouse.set_visible(False)


def show_date(message):
  font = pygame.font.Font(None,m*30) # Font size
  text = font.render(message, 1,(200,200,200))
  screen.blit(text, (m*(240-5.4*len(Top_date)),m*40)) #### (H,V)

def show_version(message):
  font = pygame.font.Font(None,m*15)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text, (250,m*300)) #### (H,V)
 
def show_timee(message):
  font = pygame.font.Font(None,m*100)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text, (m*35,m*60))  # was (35,55)

def show_theme(message):
  font = pygame.font.Font(None,30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(240-10*int(len(stheme[i])/2),100+5)) # Font is 10 pixels 

def show_theme(message):
  font = pygame.font.Font(None,30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text, (350,100))
 
def show_trains(message):
  font = pygame.font.Font(None,30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(90,130)) ### Hor.Vert
                  
  
def show_display(message):
  font = pygame.font.Font(None,m*35)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(0,m*130)) ### Hor.Vert

    
def show_displayb(message):
    
  font = pygame.font.Font(None,m*35)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(0,m*(170-15))) ### Hor.Vert
  
offa = m*20 # Horizontal shift a
offb = m*143
offc = m*330  # was 340

def show_display1a(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offa,m*190)) ### Hor.Vert
  
def show_display1b(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offb,m*190)) ### Hor.Vert

def show_display1c(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offc,m*190)) ### Hor.Vert



  

def show_display2a(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offa,m*215)) ### Hor.Vert

def show_display2b(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offb,m*215)) ### Hor.Vert

def show_display2c(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offc,m*215)) ### Hor.Vert





def show_display3a(message):   
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offa,m*240)) ### Hor.Vert

def show_display3b(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offb,m*240)) ### Hor.Vert

def show_display3c(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offc,m*240)) ### Hor.Vert



def show_display4a(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offa,m*265)) ### Hor.Vert

def show_display4b(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offb,m*265)) ### Hor.Vert

def show_display4c(message):
  font = pygame.font.Font(None,m*30)
  text = font.render(message, 1,(200,200,200))
  screen.blit(text,(offc,m*265)) ### Hor.Vert







  
###########  Build Nexttrain displays
  
print (now)
hm =now.strftime('%H:%M')
print (hm)


#### added for end of year problem

if notrains:
    display =' '
    displayb = '       We are closed until the spring.'
    display1a = '           Thank you for riding with us.'
    display2a = '     We hope to see you again next year.'
    display1b = display1c = display2b = display2c = display3a = display3b = display3c = display4a = display4b = display4c = ' '
    display3b = ' '
    
    
else:

    ########### hm= input ('Enter a time in the form of hh:mm ')


    tnow =60*int(hm[0:2]) +int(hm[3:7])
    print (tnow)
    timee = '     '+now.strftime('%-I:%M %p')

    display = "   There are no trains scheduled today."
    displayb =    '  The next train rides are scheduled for:'
    print ('Theme for nexttrain ' +stheme[nexttrain])


    #_________________
    display1a = sdow[nexttrain]+' '+make_date(sdate[nexttrain])[0:5]+ ':'
    display1c = days_out(make_date(sdate[nexttrain]))

    if stheme[nexttrain] == 'Operate-A-Loco':
       
        display1b = 'OAL '+' NO Passengers'
        #display1c = ' '
        
    elif snot[nexttrain] == '1':
        display1b = snot[nexttrain] + ' Train at ' +strain1[nexttrain]
    else:
        display1b = snot[nexttrain] + ' Trains at ' +strain1[nexttrain]
    #_________________    
         

    #_________________
    display2a = sdow[nexttrain +1]+' '+make_date(sdate[nexttrain +1])[0:5]+ ':'
    display2c = days_out(make_date(sdate[nexttrain +1]))

    if stheme[nexttrain +1] == 'Operate-A-Loco':
       
        display2b = 'OAL '+' NO Passengers'
        #display2c = ' '
        
    elif snot[nexttrain +1] == '1':
        display2b = snot[nexttrain +1] + ' Train at ' +strain1[nexttrain +1]
    else:
        display2b = snot[nexttrain +1] + ' Trains at ' +strain1[nexttrain +1]
    #_________________    
         


    #_________________
    display3a = sdow[nexttrain +2]+' '+make_date(sdate[nexttrain +2])[0:5]+ ':'
    display3c = days_out(make_date(sdate[nexttrain +2]))

    if stheme[nexttrain +2] == 'Operate-A-Loco':
       
        display3b = 'OAL '+' NO Passengers'
        #display3c = ' '
        
    elif snot[nexttrain +2] == '1':
        display3b = snot[nexttrain +2] + ' Train at ' +strain1[nexttrain +2]
    else:
        display3b = snot[nexttrain +2] + ' Trains at ' +strain1[nexttrain +2]
    #_________________    
         


    #_________________
    display4a = sdow[nexttrain +3]+' '+make_date(sdate[nexttrain +3])[0:5]+ ':'
    display4c = days_out(make_date(sdate[nexttrain +3]))

    if stheme[nexttrain +3] == 'Operate-A-Loco':
       
        display4b = 'OAL '+' NO Passengers'
        #display4c = ' '
        
    elif snot[nexttrain +3] == '1':
        display4b = snot[nexttrain +3] + ' Train at ' +strain1[nexttrain +3]
    else:
        display4b = snot[nexttrain +3] + ' Trains at ' +strain1[nexttrain +3]
    #_________________    
         

    ##############################################

try:
    while True:
        

        # tnow = int(input('Enter a time '))  ##Used in testing cd322.py
        now = datetime.now() ## current date and time
        if now.strftime('%H:%M:%S') == '00:00:01':   ##REBOOT for the next day
            
            os.system('sudo reboot')
        
      
        print (now)
        hm =now.strftime('%H:%M')
        print (hm)

      
      ########### hm= input ('Enter a time in the form of hh:mm ')
      
        tnow =60*int(hm[0:2]) +int(hm[3:5])
        print (tnow)
        timee = '     '+now.strftime('%-I:%M %p')
 
    
        print('xxxxxxxxxxxx')
        print ( 'The time now is ',tnow)

        print ('DISPLAY    '+display)
        print (displayb)
        print (nhv)
        print ('bootlog ',bootlog)
        print (tnow)
      


        screen.fill(BLACK)
        screen.blit(ball,(m*65,1))
        show_timee(timee)              
        show_date(Top_date)
        show_displayb(displayb)
        show_display(display)
    
        show_display1a(display1a)
        show_display2a(display2a)
        show_display3a(display3a)
        show_display4a(display4a)

        show_display1b(display1b)
        show_display2b(display2b)
        show_display3b(display3b)
        show_display4b(display4b)

        show_display1c(display1c)
        show_display2c(display2c)
        show_display3c(display3c)
        show_display4c(display4c)





        
        show_version(str(script)+' '+ ver)
        pygame.display.update()
        #print ('xxxxxxxxxxxxxxx')
        #print('>>>>>>>>>>>>>>>>>>>>'+snot[nexttrain+1])
      
        if bootlog == 1:
            file = open('bootlog.txt','a')
            file.write('Start NO TRAIN  ' + Top_date + timee+'\n')
            file.close()
            bootlog = 0
          
        #if tnow > 20:
        if tnow > 1438:
            file = open('bootlog.txt','a')
            file.write('Reboot from NO TRAINS ' + Top_date + timee+'\n')
            file.close()
            displayb= ('The system will reboot in 2 minutes!')
            print ('The system will reboot in 2 minutes!')
            sleep(120)
            os.system('sudo reboot')
      

        sleep(.1)

      
except (KeyboardInterrupt, SystemExit):
    print('The program was manually stopped')
    quit()



